;************************************************************
;        !:
; 
;        LCDTemp
;        LCDTemp1
; 
LCDdPort   equ   PortB  ;     
LCDenPort  equ   PortC  ;   (en) 1- 
LCDrsPort  equ   PortC  ;   (rs) 0- 1-
LCDrwPort  equ   PortB  ;   (rw) 0- 1-


RS  equ  6
RW  equ  1
EN  equ  7

;*******************************************************************
;                              76543210
         constant   fset8  = b'00110000' ;8  2 
         constant   fset4  = b'00100000' ;4  2 
         constant   DDZero = b'10000000' ;

         constant   LCD2L  = b'00101000'  ;
         constant   LCDCont= b'00001100'  ;00001100'  ;
         constant   LCDSH  = b'00101000'  ;

         constant   LCDCLR = b'00000001'  ;  lcd 
         constant   LCDCH  = b'00000010'  ;
         constant   LCDCL  = b'00000100'  ;
         constant   LCDCR  = b'00000110'  ;
         constant   LCDSL  = b'00011000'  ;
         constant   LCDSR  = b'00011100'  ;
         constant   LCDL1  = b'10000000'  ;
         constant   LCDL2  = b'11000000'  ;

;****************************************************************
;

lcdcmd   macro      LCDcomand
         movlw      LCDcomand
         call       LCDcomd
         endm

lcdclr   macro
         movlw      LCDCLR
         call       LCDcomd
         endm

LCDDDAdr macro      DDRamAdres
Local    value =    DDRamAdres | 0x80
         movlv      value
         call       LCDcomd
         endm

;****************************************************************
;  LCD       

lcdinit
         call       SetLCDPort         ; 
         call       delay1ms
         call       delay1ms
         call       delay1ms
         call       delay1ms
         call       delay1ms

         movlw      fset8
         call       SendW
         call       longdel     

         movlw      fset8
         call       SendW
         call       delay1ms
         call       delay1ms
         call       delay1ms
         call       delay1ms

         movlw      fset8
         call       SendW
         call       delay1ms
         call       delay1ms
         call       delay1ms
         call       delay1ms


         movlw      fset8
         call       SendW
         call       longdel     

         movlw      DDZero
         call       SendW


         movlw      fset4
         call       SendW

 
         lcdcmd     fset4
          

         lcdcmd     LCD2L
         lcdcmd     LCDCont
         lcdcmd     LCDCLR
         lcdcmd     LCDCR

         call       delay1ms
;         call       LCDcomd
          lcdcmd     LCDL1
          movlw      " "
          call       LCDdata  
          movlw      LCDCLR
         call       delay1ms

         return

;********************************************************

SetLCDPort
         bsf        Status,RP0
         movlw      b'00001111' 
         movwf      LCDdPort    ;     
         movlw      b'00011100' 
         movwf      TrisC       ; 
         bcf        Status,RP0  ;
         clrf       LCDdPort 

         return



LCDcomd  
         movwf      LCDTemp
         bcf        LCDrsPort,RS
         goto       LCDwr

LCDdata  
         movwf      LCDTemp
         bsf        LCDrsPort,RS

LCDwr    
         movf       LCDTemp,w
         call       SendW

         swapf      LCDTemp,w
         call       SendW
         return

SendW    
         movwf      LCDdPort
         nop
         bsf        LCDenPort,EN
         nop
         bcf        LCDenPort,EN

         movlw      0ffh
         movwf      Temp
P1
         decfsz     Temp,F
         goto       P1

         movlw      0f0h
         movwf      Temp
P2
         decfsz     Temp,F
         goto       P2

         return

;**********************************************

lcdtext  macro select, text

         local    Message
         local    Start
         local    Exit
         local    WriteText

         goto    Start


Message  addwf   PC,F        ; W + PC -> PC
         dt      text 
         dt      0

Start
         if select==1
         lcdcmd  LCDL1
         else
         if select==2
         lcdcmd  LCDL2
         endif
         endif
         movlw   HIGH Message
         movwf   PCLATH
         clrf    LCDTemp1
         movf    LCDTemp1,w
WriteText
         call    Message
         addlw   0
         bz      Exit
         call    LCDdata
         incf    LCDTemp1,f
         movf    LCDTemp1,w
         goto    WriteText
         clrf    PCLATH
      
Exit
         endm

LCDTable
            addwf      PC,F        ; W + PC -> PC
            retlw      30h ; 0
            retlw      31h ; 1
            retlw      32h ; 2
            retlw      33h ; 3
            retlw      34h ; 4
            retlw      35h ; 5
            retlw      36h ; 6
            retlw      37h ; 7
            retlw      38h ; 8
            retlw      39h ; 9
            retlw      41h ; a
            retlw      42h ; b
            retlw      43h ; c
            retlw      44h ; d
            retlw      45h ; e
            retlw      46h ; f

lcdHexByte
         movwf       LCDTemp1
         swapf       LCDTemp1,w
         andlw       b'00001111'
         call        LCDTable
         call        LCDdata

         movf        LCDTemp1,w
         andlw       b'00001111'
         call        LCDTable
         call        LCDdata
         return

;************************************************
delay1ms 
         call       delay
         call       delay
         return

EndLCDInc
